/*
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 *  Copyright (C) 1996  Ralf Baechle
 */
#include <asm/cachectl.h>
#include <asm/mipsregs.h>
#include <asm/ptrace.h>

extern asmlinkage void mips4_cacheflush(void *addr, int nbytes, unsigned int flags);

unsigned long page_colour_mask;

void (*mips_cache_init)(void);

static void
mips4_cache_init(void)
{
	/*
	 * The R10000 is in most aspects similar to the R4400.  It
	 * should get some special optimizations.
	 */
	write_32bit_cp0_register(CP0_FRAMEMASK, 0);
	set_cp0_status(ST0_XX, ST0_XX);
	/*
	 * Actually this mask stands for only 16k cache.  This is
	 * correct since the R10000 has multiple ways in it's cache.
	 */
	page_colour_mask = 0x3000;
	cacheflush = mips4_cacheflush;
	/*
	 * The R10k might even work for Linux/MIPS - but we're paranoid
	 * and refuse to run until this is tested on real silicon
	 */
	panic("CPU too expensive - making holiday in the ANDES!");
}

void (*switch_to_user_mode)(struct pt_regs *regs);

static void
mips4_switch_to_user_mode(struct pt_regs *regs)
{
	regs->cp0_status = (regs->cp0_status & ~(ST0_CU0|ST0_KSU)) | KSU_USER;
}

void
mips4_cpu_init(void)
{
	mips_cache_init = mips4_cache_init;
	switch_to_user_mode = mips4_switch_to_user_mode;
}
